#** raccess4vbox-1.1b1.tcl **
# ** 16-06-97 Gerrit Pape <laredo@cs.tu-berlin.de> Berlin Germany

# what do I say
set text(raccess_no_msg)    "quitting remote access mode"
set text(raccess_last_msg)  "no more messages, repeating last"
set text(repeat_rec)        "starting new record"
set text(run_ext_accept)    "accepted"
set text(run_ext_result)    "result"
set text(err_run_ext)       "extern program did not return 0"
set text(err_getty_play)    "while getty playing message"
set text(err_getty_rec)     "while getty recording message"
set text(err_no_act)        "no action found for this code"
set text(rcontrol_loop) "remote control mode ,,,,, exit with 2"
set text(raccess_noothermsg)  {0 $other messages}
set text(raccess_howmanymsg) \
   {$available_no($raccess(mode)) $raccess(mode) messages}
set text(raccess_err_togglenew)  {toggling new flag failed}
set text(raccess_err_toggleold)  {toggling old flag failed}
set text(raccess_msgmarked)      {message marked $other}
set text(rcontrol_ctrlremoved)   {control file $filetype is removed}
set text(rcontrol_err_removectrl) {removing control file $filetype failed}
set text(rcontrol_ctrlcreated)    {control file $filetype is cre ated}
set text(rcontrol_err_createctrl) {cre ating control file $filetype failed}
set text(rcontrol_recnew_intro) \
   {record new standard message ,,,,, start after the beep and stop with 0}
set text(rcontrol_recnew_repeatrec) \
   {repeating your message ,,,,, confirm with 8 and drop with 2}
set text(rcontrol_recnew_err_backupstd) \
   {back up of standard message failed, no changes made}
set text(rcontrol_recnew_err_createstd) \
   {writing new standard message failed ,,,, no garantee of further functions}
set text(rcontrol_recnew_confirm)       {accepted the new standard message}
set text(rcontrol_recnew_drop)          {no changes ,,, exiting}

# global actions
# more global actions 
# remote actions
# control actions
# all these actions are now placed in the rcfile.

# Tuning
set raccess(rcfile)     "raccess.conf"  ;# searched in spooldir/<user>/
set raccess(mode)       "new"           ;# default access to the new messages
set raccess(messagedir) "messages"      ;# relative to the spooldir/<user>
set raccess(say_path)   /usr/bin/say
set raccess(say_flag)   "-q -x 2000 -f 8"   ;# try yourself 
set raccess(say_breath) ",,,,,"
set raccess(say_append) ",,,,,,,,,"
set raccess(temp_file)  /tmp/vbox20-[pid]-1.tmp
set raccess(touch_path) /usr/bin/touch
set raccess(logging)    1
  set raccess(log_file)  raccess.log    ;# placed in spooldir/<user>

#
proc raccess_log { level msg } {
    global raccess
    if { $level <= $raccess(logging) } {
	puts $raccess(log_file_no) "[ clock format [ clock seconds ] ]: $msg"
	flush $raccess(log_file_no)
    }
}

# 
proc run_extern { cmd } {
    global text
    if { [ playtext $text(run_ext_accept) ] == "HANGUP" } {
	return "HANGUP"
    }
    if [ catch { eval exec -- $cmd } that ] {
	if { [ handle_error $text(err_run_ext) ] == "HANGUP" } {
	    return "HANGUP"
	}
    }
    if { [ playtext $text(run_ext_result) $that ] == "HANGUP" } {
	return "HANGUP"
    }
    return "REPEAT"
}

# 
proc playmessage { message { flag TRUE } } {
    global action text
    if { $flag == "TRUE" } {
	raccess_log 1 "Play $message"
	set what [ vbox_put_message $message ]
	if { $what != "OK" } {
	    if { $what == "HANGUP" } {
		raccess_log 1 "HANGUP"
		return "HANGUP"
	    }
	    if { $what == "ERROR" } {
		raccess_log 1 "ERROR vbox_put_message"
		return [ handle_error $text(err_getty_play) ]
	    }
	    if { [ info exists action($what) ] } {
		raccess_log 1 "GOT SEQUENZ $what"
		if { [ info exists text($what) ] } {
		    playtext $text($what)
		}
		return [ eval $action($what) ]
	    } else {
		raccess_log 1 "GOT SEQUENZ $what - action not found!!"
                return [ handle_error $text(err_no_act) ]
	    }
	}
    }
    raccess_log 1 "OK"
    return "OK"
}

proc recmessage { message reclength { flag "TRUE" } } {
    global action vbox_msg_timeout text
    if { $flag == "TRUE" } {
	raccess_log 1 "Record $message"
	set what [ vbox_get_message $message $reclength ]
	if { $what != "OK" } {
	    if { $what == "HANGUP" } {
		raccess_log 1 "HANGUP"
		return "HANGUP"
	    }
	    if { $what == "TIMEOUT" } {
		raccess_log 1 "TIMEOUT"
		return [ playmessage $vbox_msg_timeout ]
		}
	    if { $what == "ERROR" } {
		raccess_log 1 "ERROR vbox_get_message"
		return [ handle_error $text(err_getty_rec) ]
	    }
	    if { [ info exists action($what) ] } {
		raccess_log 1 "GOT SEQUENZ $what"
                if { [ info exists text($what) ] } {
                    playtext $text($what)
                }
		return [ eval $action($what) ]
	    } else {
		raccess_log 1 "GOT SEQUENZ $what - action not found!!"
		return [ handle_error $text(err_no_act) ]
	    }
	}
    }
    raccess_log 1 "OK"
    return "OK"
}

#
proc handle_error { { why "no more spezification given" } } {
    global no_of_errors
    incr no_of_errors
    raccess_log 1 "ERROR No. $no_of_errors: $why"
    if { $no_of_errors >= 9 } {
	raccess_log 1 "too many errors! hanging up myself..."
	return "HANGUP"
    }
    if { [ set what [ playtext error $why ] ] == "HANGUP" } {
	return "HANGUP"
    }
    if { $what == "ERROR" } {
	raccess_log 1 "cannot report error! hanging up by myself..."
	return "HANGUP"
    }
    raccess_log 2 "ERROR reported - REPEAT"
    return "REPEAT"
}

# 
proc playtext { string args } {
    global vbox_var_bindir
    upvar #0 raccess(say_path) say raccess(say_flag) flag \
	    raccess(say_append) append raccess(temp_file) file
    raccess_log 1 "playtext $string $args"
    if [ catch { eval exec -- $say $flag -a -o - $string $args $append | \
	    $vbox_var_bindir/autovbox | cat > $file 2> /dev/null } ] {
	raccess_log 1 "ERROR convert text2au2vbox > $file"
	if { [ string compare $string error ] == 0 } {
	    return "ERROR"
	}
	return [ handle_error "cannot convert text to soundfile" ]
    }
    set what [ playmessage [ subst $file ] ]
    if [ catch { exec -- rm -f $file } ] {
	raccess_log 1 "ERROR couldnot remove $file"
    }
    return "$what"
}

#
proc playheader { msgfile } {
    global raccess
    set stmp [ vbox_message_info $msgfile 1 ]
    if { [ llength $stmp ] > 0 } {
	set day [ clock format $stmp -format %A ]
	set hor_min [ clock format $stmp -format %R ]
	lappend header $day $hor_min $raccess(say_breath)
    }
    set cid [ vbox_message_info $msgfile 3 ]
    if { [ llength $stmp ] > 0 } {
	if { $cid != 0 } {
	    for { set i 0 } { $i < [ string length $cid ] } { incr i } {
		lappend header [ string index $cid $i ] $raccess(say_breath)
	    }
	} 
    }
    foreach item { 4 5 } {
	set who [ string trim [ vbox_message_info $msgfile $item ] {\{\}} ]
	if { [ llength $who ] > 0 } {
	    if { [ string match {*Unknown \**} $who ] != 1 } {
		lappend header $who $raccess(say_breath)
	    }
	}
    }
    playtext $header
}

#
proc install_actions_texts { naction backup ntext tbackup} {
    global action text
    upvar 1 $backup bup $naction nact $tbackup tbup $ntext ntxt
    raccess_log 2 "install_actions_texts"

    foreach item [ array names nact ] {
	if [ info exists action($item) ] {
	    raccess_log 2 "set action($item) (exists.. backup) $nact($item)"
	    set bup($item) $action($item)
	} else {
	    raccess_log 2 "set action($item) $nact($item)"
	    vbox_breaklist add $item
	}
	set action($item) $nact($item)
	if [ info exists ntxt($item) ] {
	    if [ info exists text($item) ] {
		raccess_log 2 "set text($item) (exists.. backup) $ntxt($item)"
		set tbup($item) $text($item)
	    } else {
		raccess_log 2 "set text($item) $ntxt($item)"
	    }
	    set text($item) $ntxt($item)
	} else {
	    if [ info exists text($item) ] {
		raccess_log 2 "text exists ... backup and remove"
		set tbup($item) $text($item)
		unset text($item)
	    }
	}
    }
    vbox_breaklist list
}

proc uninstall_actions_texts { naction backup ntext tbackup} {
    global action text
    upvar 1 $backup bup $naction nact $tbackup tbup $ntext ntxt
    raccess_log 2 "uninstall_actions_texts"

    foreach item [ array names nact ] {
	if [ info exists bup($item) ] {
	    raccess_log 2 "backup($item) exists ... restore"
	    set action($item) $bup($item)
	} else {
	    raccess_log 2 "remove action($item)"
	    vbox_breaklist rem $item
	    unset action($item)
	}
	if [ info exists tbup($item) ] {
	    raccess_log 2 "tbackup($item) exists ... restore"
	    set text($item) $tbup($item)
	} else {
	    raccess_log 2 "remove text($item)"
	    unset text($item)
	}
    }
    vbox_breaklist list
}

#
proc skip { } {
    return "OK"
}
proc repeat { } {
    return "REPEAT"
}

#
proc raccess_rewind { } {
    global message_no
    incr message_no -1
    if { $message_no < 0 } {
	set message_no 0
    }
    return "CONT"
}

proc raccess_forwind { } {
    global message_no
    incr message_no
    return "CONT"
}

proc raccess_first { } {
    global message_no
    set message_no 0
    return "CONT"
}

proc raccess_last { } {
    global message_no available_no raccess
    set message_no [ expr $available_no($raccess(mode)) - 1 ]
    return "CONT"
}

proc raccess_exit { } {
    return "EXIT"
}

proc raccess_switchmode { actual } {
    if { [ string compare $actual "old" ] == 0 } {
	return "new"
    } else {
	return "old"
    }
}

proc raccess_new-old { } {
    global raccess available_no message_no text
    set mode(0) "old"
    set mode(1) "new"
    set other [ raccess_switchmode $raccess(mode) ]
    if { $available_no($other) == 0 } {
	if { [ playtext [ subst $text(raccess_noothermsg) ] ] == "HANGUP" } {
	    return "HANGUP"
	}
	return "CONT"
    }
    set raccess(mode) $other
    set message_no 0
    raccess_log 2 "new_old: now $raccess(mode) Messages"
    if { [ playtext [ subst $text(raccess_howmanymsg) ] ] == "HANGUP" } {
	return "HANGUP"
    }
    return "CONT"
}

proc raccess_togglenew { } {
    global raccess vbox_var_checknew available available_no message_no text
    set other [ raccess_switchmode $raccess(mode) ]
    set msgfile [ lindex $available($raccess(mode)) $message_no ]
    if { $raccess(mode) == "old" } {
	if [ catch { exec -- $raccess(touch_path) -m $msgfile } ] {
	    if { [ playtext $text(raccess_err_togglenew) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    return "CONT"
	}
    } else {
	if [ catch \
		{ exec -- $raccess(touch_path) -m -t 0101010070 $msgfile} ] {
	    if { [ playtext $text(raccess_err_toggleold) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    return "CONT"
	}
    }
    if { [ playtext [ subst $text(raccess_msgmarked) ] ] == "HANGUP" } {
	return "HANGUP"
    }
    raccess_getmessages $vbox_var_checknew
    if { $available_no($raccess(mode)) <= 0 } {
	return [ raccess_new-old ]
    }
    return "NOOP"
}

#
proc raccess_getmessages { dir } {  
    global available available_no raccess text
    foreach item { new old } {
	if { [ info exists available($item) ] } {
	    unset available($item)
	}
    }
    foreach dum [ split [ exec ls -1tr $dir ] \n ] {
	if { [ file mtime $dir/$dum ] == 0 } {
	    lappend available(old) $dir/$dum
	} else {
	    lappend available(new) $dir/$dum
	}
    }
    foreach item { new old } {
	if { [ info exists available($item) ] } {
	    set available_no($item) [ llength $available($item) ]
	} else {
	    set available_no($item) 0
	}
    }
    if { [ playtext [ subst $text(raccess_howmanymsg) ] ] == "HANGUP" } {
	return "HANGUP"
    }

}

#
proc rcontrol_ctrl { file } {
    global vbox_var_spooldir raccess text
    set filetype [ string range $file 9 end ]
    if [ file exists $vbox_var_spooldir/$file ] {
	if [ catch { exec -- rm $vbox_var_spooldir/$file } ] {
	    if { [ playtext [ subst $text(rcontrol_err_removectrl) ] ] \
		    == "HANGUP" } {
		return "HANGUP"
	    }
	    return "REPEAT"
	} else {
	    if { [ playtext [ subst $text(rcontrol_ctrlremoved) ] ] \
		    == "HANGUP" } {
		return "HANGUP"
	    }
	    return "REPEAT"
	}
    } else {
	if [ catch \
		{ exec -- $raccess(touch_path) $vbox_var_spooldir/$file } ] {
	    if { [ playtext [ subst $text(rcontrol_err_createctrl) ] ] \
		    == "HANGUP" } {
		return "HANGUP"
	    }
	    return "REPEAT"
	} else {
	    if { [ playtext [ subst $text(rcontrol_ctrlcreated) ] ] \
		    == "HANGUP" } {
		return "HANGUP"
	    }
	    return "REPEAT"
	}
    }
    return "REPEAT"
}

#
proc rcontrol_recnewstdmsg { } {
    global vbox_msg_beep vbox_var_spooldir text raccess
    set stdnew $vbox_var_spooldir/$raccess(messagedir)/standard.msg.new
    set stdold $vbox_var_spooldir/$raccess(messagedir)/standard.msg.old
    set std    $vbox_var_spooldir/$raccess(messagedir)/standard.msg
    if { [ playtext $text(rcontrol_recnew_intro) ] == "HANGUP" } {
	return "HANGUP"
    }
    if { [ playmessage $vbox_msg_beep ] == "HANGUP" } {
	return "HANGUP"
    }
    if { [ recmessage $stdnew 120 ] == "HANGUP" } {
	return "HANGUP"
    }
    while { 1 } {
	if { [ playtext $text(rcontrol_recnew_repeatrec) ] == "HANGUP" } {
	    return "HANGUP"
	}
	if { [ set what [ playmessage $stdnew ] ] == "HANGUP" } {
	    return "HANGUP"
	}
	if { $what == "REPEAT" } {
	    if [ catch { exec -- mv $std $stdold } ] {
		return [ handle_error $text(rcontrol_recnew_err_backupstd) ]
	    }
	    if [ catch { exec -- mv $stdnew $std } ] {
		return [ handle_error $text(rcontrol_recnew_err_createstd) ]
	    }
	    if { [ playtext $text(rcontrol_recnew_confirm) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    return "REPEAT"
	}
	if { $what == "EXIT" } {
	    if { [ playtext $text(rcontrol_recnew_drop) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    return "REPEAT"
	}
    }
}

#
proc remote_control { } {
    global text
    upvar #0 rcontrol_action c_action rcontrol_action_text c_text
    raccess_log 1 "$text(rcontrol_loop)"
    install_actions_texts c_action backup c_text tbackup
    while { [ set what [ playtext $text(rcontrol_loop) ] ] != "EXIT" } {
	if { $what == "HANGUP" } {
	    return "HANGUP"
	}
    }
    uninstall_actions_texts c_action backup c_text tbackup
    return "REPEAT"
}

#
proc remote_access { } {
    global action text available available_no message_no
    global vbox_var_checknew raccess
    upvar #0 raccess_action r_action raccess_action_text r_text

    vbox_init_touchtones
    uplevel { vbox_breaklist rem $what }
    set message_no 0
    set working 1
    raccess_getmessages $vbox_var_checknew
    if { $available_no(new) == 0 } {
	set raccess(mode) "old"
	if { [ playtext [ subst $text(raccess_howmanymsg) ] ] == "HANGUP" } {
	    return "HANGUP"
	}
	if { $available_no(old) == 0 } {
	    if { [ playtext $text(raccess_no_msg) ] == "HANGUP" } {
		return "HANGUP"
	    }
	    uplevel { vbox_breaklist add $what }
	    return "REPEAT"
	}
    }
    install_actions_texts r_action backup r_text tbackup

    while { $working } {
	set msgfile [ lindex $available($raccess(mode)) $message_no ]
	while { [ set what [ playheader $msgfile ] ] == "REPEAT" } { }
	if { $what == "HANGUP" } { return "HANGUP" }
	if { $what == "EXIT" } {
	    set working 0
	    continue
	}
	if { $what != "CONT" } {
	    if { [ set what [ playmessage $msgfile ] ] == "HANGUP" } {
		return "HANGUP"
	    }
	    if { $what == "EXIT" } {
		set working 0
		continue
	    }
	    if { $what == "OK" } { incr message_no }
	}
	if { $message_no >= $available_no($raccess(mode)) } {
	    set message_no [ expr $available_no($raccess(mode)) - 1 ]
	    if { [ playtext $text(raccess_last_msg) ] == "HANGUP" } {
		return "HANGUP"
	    }
	}
	if { $available_no($raccess(mode)) == 0 } {
	    raccess_new-old
	}
    }
    uplevel { vbox_breaklist add $what }
    uninstall_actions_texts r_action backup r_text tbackup
    return "REPEAT"
}

# main, running right after accepting the call.

set no_of_errors 0
if { $raccess(logging) } {
    if [ catch { set raccess(log_file_no) \
	    [ open $vbox_var_spooldir/$raccess(log_file) a+ 0644 ] } ] {
	set raccess(logging) 0
    } else {
	raccess_log 1 "-------------------------"
	raccess_log 1 \
	  "call from $vbox_caller_id $vbox_caller_phone $vbox_caller_name"
    }
}
# read config file
if [ file readable $vbox_var_spooldir/$raccess(rcfile) ] {
    set rc [ open $vbox_var_spooldir/$raccess(rcfile) r ]
    for { set i 1 } { ! [ eof $rc ] } { incr i } {
	if { [ gets $rc line ] == 0 } { continue }
	if { [ set no [ string first ";" $line ] ] != -1 } {
	    set line [ string range $line 0 [ expr $no - 1 ] ]
	}
	if { [ llength $line ] == 0 } { continue }
	set word [ lindex $line 0 ]
	if { [ string index $word 0 ] == "\[" } {
	    set arrname [ string trim $word \[\] ]
	} else {
	    if { [ llength $line ] >= 2 } {
		if [ info exists arrname ] {
		    set ${arrname}($word) [ lindex $line 1 ]
		    raccess_log 2 \
			    "setting ${arrname}($word) [ lindex $line 1 ]"
		    if { [ llength $line ] == 3 } {
			set ${arrname}_text($word) [ lindex $line 2 ]
			raccess_log 2 \
			   "setting ${arrname}_text($word) [ lindex $line 2 ]"
		    }
		}
	    } else {
		raccess_log 1 \
			"raccess_readrc: at least 2 words expected in line $i"
	    }
	} 
    }
    catch { close $rc }
    foreach item [ array name action_text ] {
	set text($item) $action_text($item)
    }
}
vbox_breaklist rem all
foreach sequenz [ array names action ] {
    vbox_breaklist add "$sequenz"
    raccess_log 2 " set action($sequenz) $action($sequenz)"
}
while { [ set what [ playmessage $vbox_msg_standard $vbox_flag_standard ] ] \
	== "REPEAT" } { }
if { $what == "HANGUP" } {
    return
}
while { [ set what [ playmessage $vbox_msg_beep $vbox_flag_beep ] ] \
	== "REPEAT" } { }
if { $what == "HANGUP" } {
    return
}
while { [ set what [ recmessage $vbox_var_checknew/$vbox_var_savename \
	$vbox_var_rectime $vbox_flag_record ] ] == "REPEAT" } {
    if { [ playtext $text(repeat_rec) ] == "HANGUP" } {
	break
    }
}
if { $raccess(logging) } {
    catch { close $raccess(log_file_no) }
}

# reached this point, a message is recorded....
# handle record

if { [ info exists raccess(callhandler) ] } {
    catch { exec -- $raccess(callhandler) $vbox_var_savename $vbox_caller_id \
	$vbox_user_name }
}

# Return to vboxgetty at the end of the Script
return

